=== tools/gifanalyzer/Makefile ===
CFLAGS=-Wall
#LDLIBS=-lm

.PHONY:	all clean

all:	gifanalyzer

clean:
	$(RM) *.o gifanalyzer

gifanalyzer:	gifanalyzer.o
