=== debian/changelog ===
grafx2 (2.6-2) unstable; urgency=medium

  * Patch src/fileformats to fix png saving.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 21 Jan 2019 13:44:37 +0100

grafx2 (2.6-1) unstable; urgency=medium

  * New upstream version. (Closes: #918725)
  * debian/control: add libtiff-dev.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 10 Jan 2019 16:51:38 +0100
