## grafx2 2.7

=== src/Makefile ===
--- 
+++ 
@@ -22,6 +22,9 @@
 #  You should have received a copy of the GNU General Public License
 #  along with Grafx2; if not, see <http://www.gnu.org/licenses/>
 
+# make V=1   to enable verbose building
+V ?= 0
+
 # Overridable defaults
   PREFIX ?= /usr/local
   exec_prefix = $(PREFIX)
@@ -68,7 +71,7 @@
 
   CFLAGS_CACHE = $(OBJDIR)/.cflags.cache
 
-  RECOILVER = 4.3.1
+  RECOILVER = 5.0.0
 
 # Video / input API used
   API ?= sdl
@@ -94,25 +97,56 @@
 
 # There is no uname under windows, but we can guess we are there with the COMSPEC env.var
 # Windows specific
+ifdef ComSpec
+# sometimes, it is ComSpec, sometimes it is COMSPEC
+COMSPEC = $(ComSpec)
+endif
 ifdef COMSPEC
   DELCOMMAND = rm -f
   MKDIR = mkdir -p
   RMDIR = rmdir --ignore-fail-on-non-empty
   CP = cp
-  BIN = ../bin/grafx2.exe
+  BIN = ../bin/grafx2-$(API).exe
   GENERATEDOCBIN = ../bin/generatedoc.exe
-  COPT = -W -Wall -Wdeclaration-after-statement -O$(OPTIM) -g -ggdb `sdl-config --cflags` $(TTFCOPT) $(JOYCOPT) $(LUACOPT)
-  LOPT = `sdl-config --libs` -lSDL_image $(TTFLOPT) -lpng -lz $(LUALOPT)
+  COPT = -W -Wall -Wdeclaration-after-statement -O$(OPTIM) -g -ggdb
+  COPT += $(LUACOPT)
+  LOPT = -mwindows
+  LOPT += $(LUALOPT)
+  ifeq ($(API),sdl)
+  SDLCONFIG ?= $(shell which ../3rdparty/usr-win32/bin/sdl-config || which sdl-config)
+  COPT += $(shell $(SDLCONFIG) --cflags) $(TTFCOPT) $(JOYCOPT)
+  LOPT += $(shell $(SDLCONFIG) --libs) -lSDL_image $(TTFLOPT)
+  PLATFORMFILES = bin/SDL.dll bin/SDL_image.dll
+  endif
+  ifeq ($(API),sdl2)
+  SDLC2ONFIG ?= $(shell which ../3rdparty/usr-win32/bin/sdl2-config || which sdl2-config)
+  COPT += $(shell $(SDL2CONFIG) --cflags) $(TTFCOPT) $(JOYCOPT)
+  LOPT += $(shell $(SDL2CONFIG) --libs) -lSDL2_image $(TTFLOPT)
+  PLATFORMFILES = bin/SDL2.dll bin/SDL2_image.dll
+  endif
+  ifeq ($(API),win32)
+  COPT += -I../3rdparty/usr-win32/include $(TTFCOPT)
+  LOPT += -L../3rdparty/usr-win32/lib -lgdi32 -lcomdlg32
+  PLATFORMFILES =
+  endif
+  LOPT += -lmpr
+  LOPT += -ltiff
+  LOPT += -lpng -lz
   LUALOPT = -llua
-  OBJDIR = ../obj/win32
+  OBJDIR = ../obj/win32-$(API)
   # Resources (icon)
   WINDRES = windres.exe
   PLATFORMOBJ = winres.o
   PLATFORM = win32
   #some misc files we have to add to the release archive under windows.
-  PLATFORMFILES = bin/SDL.dll bin/SDL_image.dll $(wildcard ../bin/libpng*.dll) $(wildcard ../bin/libjpeg*.dll) bin/zlib1.dll $(TTFLIBS)
+  PLATFORMFILES += $(wildcard ../bin/libpng*.dll) $(wildcard ../bin/libjpeg*.dll) bin/zlib1.dll $(TTFLIBS)
   PLATFORMFILES += bin/libtiff-5.dll
+  ifdef APPVEYOR
+  ZIP = 7z
+  ZIPOPT = a
+  else
   ZIP = zip
+  endif
 else
 
 # default for GENERATEDOCBIN
@@ -184,22 +218,28 @@
     # Where the SDL frameworks are located
     FWDIR = /Library/Frameworks
     BIN = ../bin/grafx2-$(API)
+    TESTSBIN = ../bin/tests-$(API)
+    PKG_CONFIG_PATH ?= $(shell if [ -d ../3rdparty/usr/lib/pkgconfig ] ; then echo "$${PWD}/../3rdparty/usr/lib/pkgconfig" ; fi )
+ifneq ($(PKG_CONFIG_PATH), )
+    PKG_CONFIG := PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG)
+endif
 
 ifeq ($(API),sdl)
-    SDLCONFIG := $(shell which sdl-config)
+    SDLCONFIG := $(shell which ../3rdparty/usr/bin/sdl-config || which sdl-config)
 ifneq ($(SDLCONFIG), )
     # these are for use with macports
-    SDLCOPT = $(shell sdl-config --cflags)
+    SDLCOPT = $(shell $(SDLCONFIG) --cflags)
   ifeq ($(OSX_STATIC), 1)
-    SDLLOPT = $(shell sdl-config --static-libs | sed 's/-lSDL //' | sed 's/-lX[^ ]*//g' | sed 's/-L[^ ]*//g')
+    SDLLOPT = $(shell $(SDLCONFIG) --static-libs | sed 's/-lSDL //' | sed 's/-lX[^ ]*//g' | sed 's/-L[^ ]*//g')
     SDLLIBDIR = $(shell $(PKG_CONFIG) --variable=libdir SDL_image)
     #SDLLOPT += $(SDLLIBDIR)/libSDL.a
     SDLLOPT += $(addsuffix .a, $(shell ../tools/osx_find_dependencies.sh $(SDLLIBDIR)/libSDL_image.dylib $(SDLLIBDIR)/libSDL_ttf.dylib | grep -v SDL | cut -d'.' -f 1))
     SDLLOPT += $(SDLLIBDIR)/libSDL_image.a
-    TTFLOPT =
-    SDLLOPT += $(shell $(PKG_CONFIG) --variable=libdir SDL_ttf)/libSDL_ttf.a
-  else
-    SDLLOPT = $(shell sdl-config --libs) $(shell $(PKG_CONFIG) --libs SDL_image)
+    TTFLOPT = $(shell if [ -f ../3rdparty/usr/lib/libfreetype.dylib ] && \
+      otool -L ../3rdparty/usr/lib/libfreetype.dylib | cut -f 2 | grep -q ^/usr/lib/libbz2 ; then echo "-lbz2" ; fi )
+    TTFLOPT += $(shell $(PKG_CONFIG) --variable=libdir SDL_ttf)/libSDL_ttf.a
+  else
+    SDLLOPT = $(shell $(SDLCONFIG) --libs) $(shell $(PKG_CONFIG) --libs SDL_image)
   endif
 else
     # these are for use with Mac OS X native frameworks
@@ -209,24 +249,30 @@
 endif
 endif
 ifeq ($(API),sdl2)
-    SDLCOPT = $(shell sdl2-config --cflags)
+    SDL2CONFIG := $(shell which ../3rdparty/usr/bin/sdl2-config || which sdl2-config)
+    SDLCOPT = $(shell $(SDL2CONFIG) --cflags)
     #TTFCOPT = $(shell $(PKG_CONFIG) --cflags SDL2_ttf)
   ifeq ($(OSX_STATIC), 1)
-    SDLLOPT = $(shell sdl2-config --static-libs | sed 's/-lSDL2//' | sed 's/-L[^ ]*//')
+    SDLLOPT = $(shell $(SDL2CONFIG) --static-libs | sed 's/-lSDL2//' | sed 's/-L[^ ]*//')
     SDLLIBDIR = $(shell $(PKG_CONFIG) --variable=libdir SDL2_image)
     SDLLOPT += $(SDLLIBDIR)/libSDL2.a
     # trick to get all dependencies
     SDLLOPT += $(addsuffix .a, $(shell ../tools/osx_find_dependencies.sh $(SDLLIBDIR)/libSDL2_image.dylib $(SDLLIBDIR)/libSDL2_ttf.dylib | grep -v SDL2 | cut -d'.' -f 1))
     SDLLOPT += $(SDLLIBDIR)/libSDL2_image.a
-    TTFLOPT =
-    SDLLOPT += $(shell $(PKG_CONFIG) --variable=libdir SDL2_ttf)/libSDL2_ttf.a
-  else
-    SDLLOPT = $(shell sdl2-config --libs) $(shell $(PKG_CONFIG) --libs SDL2_image)
+    TTFLOPT = $(shell if [ -f ../3rdparty/usr/lib/libfreetype.dylib ] && \
+      otool -L ../3rdparty/usr/lib/libfreetype.dylib | cut -f 2 | grep -q ^/usr/lib/libbz2 ; then echo "-lbz2" ; fi )
+    TTFLOPT += $(shell $(PKG_CONFIG) --variable=libdir SDL2_ttf)/libSDL2_ttf.a
+  else
+    SDLLOPT = $(shell $(SDL2CONFIG) --libs) $(shell $(PKG_CONFIG) --libs SDL2_image)
     SDLLOPT += -Wl,-framework,Cocoa
     TTFLOPT = $(shell $(PKG_CONFIG) --libs SDL2_ttf)
   endif
 endif
 
+ifneq ($(shell if [ -f ../3rdparty/usr/lib/liblua.a ] ; then echo "3rdparty"; fi), )
+    LUACOPT = -I../3rdparty/usr/include
+    LUALOPT = ../3rdparty/usr/lib/liblua.a
+else
     # these are for use with macports
     LUAPKG := $(shell for p in lua lua5.3 lua-5.3 lua53 lua5.2 lua-5.2 lua52 lua5.1 lua-5.1 lua51 ; do $(PKG_CONFIG) --exists $$p && echo $$p && break ; done)
 ifneq ($(LUAPKG), )
@@ -246,6 +292,7 @@
     LUALOPT = -llua 
 endif
 endif
+endif
 
     # these are for everyone
     COPT = -D_DARWIN_C_SOURCE -D__macosx__ -W -Wall -Wdeclaration-after-statement -O$(OPTIM) -std=c99 -g $(LUACOPT) $(SDLCOPT) $(TTFCOPT) -I/usr/include
@@ -255,15 +302,12 @@
 ifdef MACOSX_LION
     LOPT = $(SDLLOPT) $(LUALOPT) -framework libpng14 -lz
 else
-    LOPT = $(SDLLOPT) $(LUALOPT)
+    LOPT = $(SDLLOPT) $(LUALOPT) $(TTFLOPT)
+    LIBPNGCONFIG := $(shell which ../3rdparty/usr/bin/libpng-config || which libpng-config)
+ifneq ($(LIBPNGCONFIG), )
+    COPT += $(shell $(LIBPNGCONFIG) --cflags)
     ifneq ($(OSX_STATIC), 1)
-      LOPT += $(TTFLOPT)
-    endif
-    LIBPNGCONFIG := $(shell libpng-config)
-ifneq ($(LIBPNGCONFIG), )
-    COPT += $(shell libpng-config --cflags)
-    ifneq ($(OSX_STATIC), 1)
-    LOPT += $(shell libpng-config --ldflags)
+    LOPT += $(shell $(LIBPNGCONFIG) --ldflags)
     endif
 else
     LOPT += -lpng
@@ -286,6 +330,7 @@
 endif
     FCLOPT = 
     MACAPPEXE = Grafx2.app/Contents/MacOS/Grafx2
+    APPZIPNAME = Grafx2.app-$(shell uname -m | sed 's/Power Macintosh/powerpc/')-$(API)-$(VERSIONTAG).zip
     #NOTTF = 1
   else
   ifeq ($(PLATFORM),AROS) # 3
@@ -295,63 +340,3 @@
     RMDIR = rmdir --ignore-fail-on-non-empty
     CP = cp
     BIN = ../bin/grafx2
-    COPT = -Wall -g $(shell sdl-config --cflags) $(TTFCOPT)
-    LOPT = -lSDL_image $(shell sdl-config --libs) -lpng -ljpeg -lz $(TTFLOPT) -lfreetype2shared
-    OBJDIR = ../obj/aros
-    STRIP = strip --strip-unneeded --remove-section .comment
-    ZIP = lha
-    ZIPOPT = a
-
-  else
-  ifeq ($(PLATFORM),MorphOS) # 4
-    #MorphOS specific
-    DELCOMMAND = rm -rf
-    MKDIR = mkdir -p
-    RMDIR = rmdir --ignore-fail-on-non-empty
-    CP = cp
-    BIN = ../bin/grafx2
-    COPT = -Wall -gstabs $(shell sdl-config --cflags) $(TTFCOPT)
-    LOPT = -lSDL_image $(shell sdl-config --libs) -lpng -ljpeg -lz $(TTFLOPT)
-    OBJDIR = ../obj/morphos
-    ZIP = lha
-    ZIPOPT = a
-    PLATFORMFILES = ../misc/grafx2.info
-
-  else
-  ifeq ($(PLATFORM),BeOS) # 6
-    #BeOS specific
-    DELCOMMAND = rm -rf
-    MKDIR = mkdir -p
-    RMDIR = rmdir --ignore-fail-on-non-empty
-    CP = cp
-    BIN = ../bin/grafx2
-    COPT = -W -Wall -g $(shell sdl-config --cflags) $(TTFCOPT) -I/boot/home/config/include
-    LOPT = $(shell sdl-config --libs) -lSDL_image -lpng -ljpeg -lz $(TTFLOPT)
-    OBJDIR = ../obj/beos
-    ZIP = zip
-
-  else
-  ifeq ($(PLATFORM),Haiku) # 7
-    #Haiku specific
-    DELCOMMAND = rm -rf
-    MKDIR = mkdir -p
-    RMDIR = rmdir --ignore-fail-on-non-empty
-    CP = cp
-    BIN = ../bin/grafx2
-    PLATFORMOBJ = haiku.o
-    ifeq ($(NOLUA),1)
-      LUACOPT =
-      LUALOPT =
-    else
-      LUAPKG=lua
-      LUACOPT = -D__ENABLE_LUA__ $(shell $(PKG_CONFIG) $(LUAPKG) --cflags)
-      LUALOPT = $(shell $(PKG_CONFIG) $(LUAPKG) --libs)
-    endif
-    COPT = -W -Wall -g $(shell sdl-config --cflags) $(TTFCOPT) -I/boot/common/include $(LUACOPT)
-    COPT += -DENABLE_FILENAMES_ICONV
-    LOPT = $(shell sdl-config --libs) -lSDL_image -lpng -ljpeg -lz $(TTFLOPT) -lfreetype -lbe $(LUALOPT) -liconv -ltiff
-    #Append the gcc kind to the objdir (gcc2 or gcc4) to avoid conflicts when switching from one to other.
-    OBJKIND = $(shell gcc -dumpversion)
-    OBJDIR = ../obj/haiku/$(OBJKIND)
-    ZIP = zip
-
