=== debian/changelog ===
grafx2 (2.7-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 17 Mar 2020 23:34:22 -0700

grafx2 (2.7-1) unstable; urgency=medium

  * New upstream version.
  * Add Vcs fields.
  * Bump standards version to 4.5.0.
  * debian/patches: dropped.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sat, 01 Feb 2020 13:19:22 +0100

grafx2 (2.6+git20191023-1) experimental; urgency=medium

  * New upstream version.
  * Bump standards version to 4.4.1.
  * d/copyright: update to machine readable format.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 23 Oct 2019 07:35:38 +0200
