=== debian/control ===
--- 
+++ 
@@ -1,14 +1,27 @@
 Source: grafx2
 Section: graphics
 Priority: optional
-Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
-Build-Depends: debhelper (>= 11), libsdl2-dev, libsdl2-image-dev, libsdl2-ttf-dev, liblua5.3-dev | liblua5.1-0-dev, libpng-dev, pkg-config, libfontconfig1-dev, dh-exec, libtiff-dev
-Standards-Version: 4.2.1
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
+Build-Depends: debhelper (>= 11),
+               dh-exec,
+               libfontconfig1-dev,
+               liblua5.3-dev | liblua5.1-0-dev,
+               libpng-dev,
+               libsdl2-dev,
+               libsdl2-image-dev,
+               libsdl2-ttf-dev,
+               libtiff-dev,
+               pkg-config
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/multimedia-team/grafx2
+Vcs-Git: https://salsa.debian.org/multimedia-team/grafx2.git
 Homepage: http://pulkomandy.tk/projects/GrafX2
 
 Package: grafx2
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-tuffy
+Depends: fonts-tuffy, ${misc:Depends}, ${shlibs:Depends}
 Description: ultimate 256-color bitmap paint program
  This is a bitmap paint program that allows you to draw in more than 60 video
  resolutions (from 320x200 to 1024x768, including most of the standard Amiga
