=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export API=sdl2
export V=1

%:
	dh $@ --sourcedirectory=src

override_dh_auto_install:
	@echo Do not use install target of upstream Makefile

override_dh_auto_test:
	@echo Skip test

override_dh_strip:
	dh_strip --no-automatic-dbgsym
