## grafx2 2.8%2Bds

=== debian/changelog ===
grafx2 (2.8+ds-4) unstable; urgency=medium

  * Bump standards version to 4.7.0.
  * d/control: update build-depends pkg-config to pkgconf,
    libfontconfig1-dev to libfontconfig-dev.

 -- Alex Myczko <tar@debian.org>  Mon, 22 Jul 2024 12:58:55 +0000

grafx2 (2.8+ds-3) unstable; urgency=medium

  * Apply upstream patch to fix text tool. (Closes: #1009703)
  * Update maintainer address.
  * Bump standards version to 4.6.1.

 -- Gürkan Myczko <tar@debian.org>  Fri, 07 Oct 2022 13:48:48 +0200

grafx2 (2.8+ds-2) unstable; urgency=medium

  * Upload to unstable

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sun, 15 Aug 2021 11:49:53 +0200

grafx2 (2.8+ds-1) experimental; urgency=medium

  * New upstream version. (Closes: #985544)
  * d/copyright: update years, add Upstream-Contact.
  * Bump standards version to 4.5.1.
  * Bump debhelper version to 13, drop d/compat.
  * d/upstream/metadata: added.
  * d/control: added Rules-Requires-Root.
  * d/watch: drop template part.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 25 Mar 2021 10:58:12 +0100
